package hdm.mi.growbros.repositories;

import hdm.mi.growbros.models.GardenEntry;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface GardenRepository extends JpaRepository<GardenEntry, Long> {
    @Query("""
                SELECT ge FROM GardenEntry ge
                ORDER BY
                    CASE
                        WHEN :week <= ge.plant.harvestWeekStart
                            THEN ABS(:week - ge.plant.harvestWeekStart)
                        ELSE ABS(52 + :week - ge.plant.harvestWeekStart)
                    END,
                    ge.plant.name
                ASC
            """)
    List<GardenEntry> findAllByNearestHarvestWeek(@Param("week") int currentWeek);

    @Query("""
                SELECT ge FROM GardenEntry ge
                ORDER BY
                    CASE
                        WHEN :week <= ge.plant.plantWeekStart
                            THEN ABS(:week - ge.plant.plantWeekStart)
                        ELSE ABS(52 + :week - ge.plant.plantWeekStart)
                    END,
                    ge.plant.name
                ASC
            """)
    List<GardenEntry> findAllByNearestPlantingWeek(@Param("week") int currentWeek);
}
